// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"


void RunRemeshing(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/ObscuredTeapot/Teapot.obj" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load ObscuredTeapot/Teapot.obj.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	// Create the remeshing processor. 
	Simplygon::spRemeshingProcessor sgRemeshingProcessor = sg->CreateRemeshingProcessor();

	sgRemeshingProcessor->SetScene( sgScene );

	Simplygon::spRemeshingSettings sgRemeshingSettings = sgRemeshingProcessor->GetRemeshingSettings();

	// Set on-screen size target for remeshing. 
	sgRemeshingSettings->SetOnScreenSize( 300 );

	// Enable hole filling. 
	sgRemeshingSettings->SetHoleFilling( Simplygon::EHoleFilling::Medium );

	// Start the remeshing process. 
	sgRemeshingProcessor->RunProcessing();

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgScene);
	sgSceneExporter->SetExportFilePath( "RemeshingOutput.fbx" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save RemeshingOutput.fbx.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	RunRemeshing(sg);

	Simplygon::Deinitialize(sg);
}

